Bash-Snippets/crypt/crypt

121 lines
4.1 KiB
Bash
Executable File

#!/bin/bash
# Author: Alexander Epstein https://github.com/alexanderepstein
currentVersion="1.5.0"
## uses openssl aes 256 cbc encryption to encrypt file salting it with password designated by user
encrypt()
{
openssl enc -aes-256-cbc -salt -a -in $1 -out $2 || { echo "File not found"; exit 1; }
echo "Successfully encrypted"
}
## uses openssl aes 256 cbc decryption to decrypt file
decrypt()
{
openssl enc -aes-256-cbc -d -a -in $1 -out $2 || { echo "File not found"; exit 1; }
echo "Successfully decrypted"
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(curl -s https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd ~ || { echo 'Update Failed' ; exit 1 ; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;}
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
usage()
{
echo "Crypt tool"
echo "Usage: crypt [flag] [inputFile] [outputFile]"
echo " -e Encrypt the inputFile and store it in the outputFile"
echo " -d Decrypt the inputFile and store it in the outputFile"
echo " -u Update Bash-Snippet Tools"
echo " -h Show the help"
echo " -v Get the tool version"
}
while getopts "huve:d:" opt; do ## alows for using options in bash
case $opt in
e) ## when trying to encrypt run this
if [[ $# -ne 3 ]]; then
echo "Option -e needs and only accepts two arguments [file to encrypt] [output file]" <&2
exit 1
fi
encrypt $2 $3
;;
\?)
echo "Invalid option: -$OPTARG" >&2
exit 1
;;
d) ## when trying to decrypt run this
if [[ $# -ne 3 ]]; then
echo "Option -d needs and only accepts two arguments [file to decrypt] [output file]" <&2
exit 1
fi
decrypt $2 $3
;;
u)
update
exit 0
;;
h)
usage
exit 0
;;
v)
echo "Version $currentVersion"
exit 0
;;
:) ## will run when no arguments are provided to to e or d options
echo "Option -$OPTARG requires an argument." >&2
exit 1
;;
esac
done
if [[ $# == 0 ]]; then
usage
elif [[ $1 == "update" ]];then
update
exit 0
elif [[ $1 == "help" ]];then
usage
exit 0
fi